Unverified Commit 3bb23e8e authored by Luiz's avatar Luiz Committed by GitHub

feat(transfer): allow encryption of uploads using GPG (#9983)

Co-authored-by: 's avatarMarc Cornellà <hello@mcornella.com>
parent 5b2f99bc
...@@ -2,23 +2,40 @@ ...@@ -2,23 +2,40 @@
[`transfer.sh`](https://transfer.sh) is an easy to use file sharing service from the command line [`transfer.sh`](https://transfer.sh) is an easy to use file sharing service from the command line
## Usage To use it, add `transfer` to the plugins array in your zshrc file:
Add `transfer` to your plugins array in your zshrc file:
```zsh ```zsh
plugins=(... transfer) plugins=(... transfer)
``` ```
Then you can: ## Usage
- transfer a file: - Transfer a file: `transfer file.txt`.
```zsh - Transfer a whole directory (it will be automatically compressed): `transfer dir`.
transfer file.txt
```
- transfer a whole directory (it will be automatically compressed): ### Encryption / Decryption
```zsh - Encrypt and upload a file with symmetric cipher and create ASCII armored output:
transfer directory/
``` ```zsh
transfer file -ca
```
- Encrypt and upload directory with symmetric cipher and gpg output:
```zsh
transfer directory -ca
```
- Decrypt file:
```zsh
gpg -d file -ca
```
- Decrypt directory:
```zsh
gpg -d your_archive.tgz.gpg | tar xz
```
# transfer.sh Easy file sharing from the command line
# transfer Plugin
# Usage Example :
# > transfer file.txt
# > transfer directory/
# Author: # Author:
# Remco Verhoef <remco@dutchcoders.io> # Remco Verhoef <remco@dutchcoders.io>
# https://gist.github.com/nl5887/a511f172d3fb3cd0e42d # https://gist.github.com/nl5887/a511f172d3fb3cd0e42d
# Modified to use tar command instead of zip # Modified to use tar command instead of zip
# #
curl --version 2>&1 > /dev/null transfer() {
if [ $? -ne 0 ]; then # check arguments
echo "Could not find curl." if [[ $# -eq 0 ]]; then
cat <<EOF
Error: no arguments specified.
Usage: transfer [file/folder] [options]
Examples:
transfer /tmp/test.md
transfer /tmp/test.md -ca
cat /tmp/test.md | transfer test.md
cat /tmp/test.md | transfer test.md -ca
Options:
-ca Encrypt file with symmetric cipher and create ASCII armored output
EOF
return 1 return 1
fi fi
transfer() { if (( ! $+commands[curl] )); then
# check arguments echo "Error: curl is not installed"
if [ $# -eq 0 ]; return 1
then fi
echo "No arguments specified. Usage:\necho transfer /tmp/test.md\ncat /tmp/test.md | transfer test.md"
return 1 local tmpfile tarfile item basename
# get temporarily filename, output is written to this file show progress can be showed
tmpfile=$(mktemp -t transferXXX)
# upload stdin or file
item="$1"
# crypt file with symmetric cipher and create ASCII armored output
local crypt=0
if [[ "$2" = -ca ]]; then
crypt=1
if (( ! $+commands[gpg] )); then
echo "Error: gpg is not installed"
return 1
fi
fi
if ! tty -s; then
# transfer from pipe
if (( crypt )); then
gpg -aco - | curl -X PUT --progress-bar -T - "https://transfer.sh/$item" >> $tmpfile
else
curl --progress-bar --upload-file - "https://transfer.sh/$item" >> $tmpfile
fi fi
else
basename=$(basename "$item" | sed -e 's/[^a-zA-Z0-9._-]/-/g')
# get temporarily filename, output is written to this file show progress can be showed if [[ ! -e $item ]]; then
tmpfile=$( mktemp -t transferXXX ) echo "File $item doesn't exist."
return 1
# upload stdin or file fi
file=$1
if tty -s; if [[ -d $item ]]; then
then # tar directory and transfer
basefile=$(basename "$file" | sed -e 's/[^a-zA-Z0-9._-]/-/g') tarfile=$(mktemp -t transferXXX.tar.gz)
cd $(dirname $item) || {
echo "Error: Could not change to directory $(dirname $item)"
return 1
}
if [ ! -e $file ]; tar -czf $tarfile $(basename $item)
then if (( crypt )); then
echo "File $file doesn't exists." gpg -cao - "$tarfile" | curl --progress-bar -T "-" "https://transfer.sh/$basename.tar.gz.gpg" >> $tmpfile
return 1 else
fi curl --progress-bar --upload-file "$tarfile" "https://transfer.sh/$basename.tar.gz" >> $tmpfile
fi
if [ -d $file ]; rm -f $tarfile
then else
echo $file # transfer file
# tar directory and transfer if (( crypt )); then
tarfile=$( mktemp -t transferXXX.tar.gz ) gpg -cao - "$item" | curl --progress-bar -T "-" "https://transfer.sh/$basename.gpg" >> $tmpfile
cd $(dirname $file) && tar -czf $tarfile $(basename $file) else
curl --progress-bar --upload-file "$tarfile" "https://transfer.sh/$basefile.tar.gz" >> $tmpfile curl --progress-bar --upload-file "$item" "https://transfer.sh/$basename" >> $tmpfile
rm -f $tarfile fi
else
# transfer file
curl --progress-bar --upload-file "$file" "https://transfer.sh/$basefile" >> $tmpfile
fi
else
# transfer pipe
curl --progress-bar --upload-file "-" "https://transfer.sh/$file" >> $tmpfile
fi fi
fi
# cat output link
cat $tmpfile # cat output link
# add newline cat $tmpfile
echo # add newline
echo
# cleanup # cleanup
rm -f $tmpfile rm -f $tmpfile
} }
Markdown is supported
0% or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment